//+------------------------------------------------------------------+
//|                                                OsMASignal_v1.mq4 |
//|                                  Copyright  2006, Forex-TSD.com |
//|                         Written by IgorAD,igorad2003@yahoo.co.uk |   
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |                                      
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"
//---- indicator settings
#property  indicator_chart_window
#property  indicator_buffers 2
#property  indicator_color1  LightBlue
#property  indicator_color2  Tomato
//---- indicator parameters
extern int Price           = 0;
extern int FastMA          =12;
extern int SlowMA          =26;
extern int SignalMA        = 9;
extern int ModeMA          = 1;
extern int ModeSignalMA    = 1;
extern double SignalLevel  = 0;

//---- indicator buffers
double     BuySignal[];
double     SellSignal[];
double     OsMA[];
double     ind_buffer2[];
double     ind_buffer3[];
double     BuyDot[];
double     SellDot[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- 2 additional buffers are used for counting.
   IndicatorBuffers(7);
//---- drawing settings
   SetIndexStyle(0,DRAW_ARROW,3);
   SetIndexArrow(0,108);
   SetIndexDrawBegin(0,SlowMA);
   
   SetIndexStyle(1,DRAW_ARROW,3);
   SetIndexArrow(1,108);
   SetIndexDrawBegin(1,SlowMA);
   
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+2);
//---- 
   SetIndexBuffer(0,BuySignal);
   SetIndexBuffer(1,SellSignal);
   SetIndexBuffer(2,OsMA);
   SetIndexBuffer(3,ind_buffer2);
   SetIndexBuffer(4,ind_buffer3);
   SetIndexBuffer(5,BuyDot);
   SetIndexBuffer(6,SellDot);  
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("OsMASignal("+FastMA+","+SlowMA+","+SignalMA+")");
   SetIndexLabel(0,"BuySignal"); 
   SetIndexLabel(1,"SellSignal"); 

//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Average of Oscillator                                     |
//+------------------------------------------------------------------+
int start()
  {
   int i, limit;
   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- macd counted in the 1-st additional buffer
   for( i=limit; i>=0; i--)
      ind_buffer2[i]=iMA(NULL,0,FastMA,0,ModeMA,Price,i)-iMA(NULL,0,SlowMA,0,ModeMA,Price,i);
//---- signal line counted in the 2-nd additional buffer
   for(i=limit; i>=0; i--)
      ind_buffer3[i]=iMAOnArray(ind_buffer2,0,SignalMA,0,ModeSignalMA,i);
//---- main loop
   for(i=limit; i>=0; i--)
      
      OsMA[i]=ind_buffer2[i]-ind_buffer3[i];
   
   for(i=limit; i>=0; i--)
      {   
      BuyDot[i]=BuyDot[i+1];
      SellDot[i]=SellDot[i+1];
      
      if(OsMA[i] <-SignalLevel && OsMA[i]>OsMA[i+1]) BuyDot[i]=1; else BuyDot[i]=0; 
      if(OsMA[i] > SignalLevel && OsMA[i]<OsMA[i+1]) SellDot[i]=1; else SellDot[i]=0;
      
      if( BuyDot[i]>0 && BuyDot[i+1]==0 ) 
      { BuySignal[i] = Low[i]-3*Point; SellSignal[i] = EMPTY_VALUE;}
            
      if( SellDot[i]>0 && SellDot[i+1]==0 ) 
      {SellSignal[i] = High[i]+3*Point; BuySignal[i] = EMPTY_VALUE;}
      
      } 
//---- 
   
   return(0);
  }
//+------------------------------------------------------------------+

